Ext.define('DSS.component.ActionConfigurator', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    height : '100%',
    layout : 'border',
    selectedElement : null,
    gridStore : null,
    grids : {},
    mainGrid : null,
    macPanel : null,
    lblSelectorAnzeige : null,
    iDefaultWidth : 150,
    iDefaultHeight : 293,
    oButtonNew : null,
    oButtonEdit : null,
    oButtonUp : null,
    oButtonDown : null,
    oButtonDelete : null,
    oActualValue : null,
    updatePanelDescription: function() {
       
        if (this.oActualValue==null) {
            this.macPanel.setTitle('Aktivit&auml;t Bearbeiten: Unvollst&auml;ndige Aktivit&auml;t');
        } else {
            switch (this.oActualValue.type) {
                case 'zone-scene': { // scene, group,zone,force
                    var sString = "";

                    if (this.oActualValue.params.force)
                        sString += 'Alles ';
                    
                    sString += dss.staticDataModel.getNameForScene(this.oActualValue.params.zone, this.oActualValue.params.group, this.oActualValue.params.scene);
                    
                    if (this.oActualValue.params.group != 0)
                        sString += " f&uuml;r " + dss.staticDataModel.getNameForGroup(this.oActualValue.params.zone, this.oActualValue.params.group);
                    if (this.oActualValue.params.zone != 0)
                        sString += " in " + dss.staticDataModel.getNameForZone(this.oActualValue.params.zone);
                    this.macPanel.setTitle('Aktivit&auml;t Bearbeiten: '+sString);
                    return;
                    break;
                }
                case 'device-scene': {// scene, dsid,force
                    var oDevice = dss.staticDataModel.getDevice(this.oActualValue.params.dsid);

                    var sString = oDevice.name + " in ";
                    sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);

                    if (this.oActualValue.params.scene == 13) {// aus
                        sString = sString + " ausschalten";
                    } else if (this.oActualValue.params.scene == 14) {// ein
                        sString = sString + " einschalten";
                    } else if (this.oActualValue.scene == 51) { // ein loc
                        sString = sString + " einschalten mit Lokalpriorit&auml;t";
                    } else {                        
                        sString = dss.staticDataModel.getNameForScene(oDevice.ZoneID, oDevice.GroupID, this.oActualValue.params.scene) + " f&uuml;r " + sString;
                        if (this.oActualValue.params.force)
                            sString = 'Alles ' + sString;
                    }
                    this.macPanel.setTitle('Aktivit&auml;t Bearbeiten: '+sString);
                    return;
                    break;
                }
                case 'device-value': { // value, dsid
                    var oDevice = dss.staticDataModel.getDevice(this.oActualValue.params.dsid);
                    var sString = "" + Math.round(this.oActualValue.params.value / 2.55) + "% f&uuml;r ";
                    sString += oDevice.name + " in ";
                    sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                    this.macPanel.setTitle('Aktivit&auml;t Bearbeiten: '+sString);
                    return;
                    break;
                }
                case 'device-blink': {// dsid
                    var oDevice = dss.staticDataModel.getDevice(this.oActualValue.params.dsid);
                    var sString = oDevice.name + " in ";
                    sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                    sString += " blinkt";
                    this.macPanel.setTitle('Aktivit&auml;t Bearbeiten: '+sString);
                    return;
                    break;
                }
                case 'zone-blink': {// group,zone
                    var sString = dss.staticDataModel.getNameForGroup(this.oActualValue.params.zone, this.oActualValue.params.group) + " in ";
                    sString += dss.staticDataModel.getNameForZone(this.oActualValue.params.zone);
                    sString += " blinkt";
                    this.macPanel.setTitle('Aktivit&auml;t Bearbeiten: '+sString);
                    return;
                    break;
                }
                case 'custom-event': { // event
                    this.macPanel.setTitle('Aktivit&auml;t Bearbeiten: Handlung ' + dss.staticDataModel.getHLENameFromId(this.oActualValue.params.event));
                    return;
                    break;
                }
                case 'url': { // url
                    this.macPanel.setTitle('Aktivit&auml;t Bearbeiten: URL: ' + this.oActualValue.params.url);
                    return;
                    break;
                }
            }
            this.macPanel.setTitle('Aktivit&auml;t Bearbeiten: Unvollst&auml;ndige Aktivit&auml;t');            
        }
    },
    setHeight : function(oHeight) {
        this.macPanel.setHeight(oHeight - 30);
        this.iDefaultHeight = oHeight - 57;
        for ( var oKey in this.grids)
            this.grids[oKey].setHeight(this.iDefaultHeight);
        this.callParent(arguments);
    },
    defMacGridRenderer : function(val, metadata, record, colIdx, store, view) {
        if (record.get('name') == '-') {
            return '<hr>';
        } 
        var fHasIcon=false;
        if (record.get('icon') != null)
        {
            fHasIcon=true;
        }
        var fHasNext=false;
        if (record.get('next') == true)  // definition erfordert weiterbutton
        {
            fHasNext=true;
        }
        if (record.get('group') != null)   // ist eine gruppe -> weiterbutton
        {
            fHasNext=true;
        }
        if (record.get('dSID') != null)    // ist ein device -> weiterbutton
        {
            fHasNext=true;
        }
        var fIsCheckable=false;
        if (record.get('checkable') != null) 
            if (record.get('checkable')) {
                fHasNext=false; // checkboxen niemals weiterbuttons
                fHasIcon=false; // keine Icons nach Checkboxen
                fIsCheckable=true;
            }

        var fIsPassive=false;        
        if (record.get('passive')!=null)
            if (record.get('passive'))
                fIsPassive=true;
        if (fIsPassive) {
            fHasNext=false;               // spalte disabled -> niemals weiterbutton
            fIsChecked=false;             // spalte disabled -> kann nicht gechecked sein
        }

        var sReturn="<table><tr>";
        var iColspaceCounter=3;
        if (fHasIcon)
        {
            iColspaceCounter--;  
            sReturn+='<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';
        }
        if (fIsCheckable)
        {
            iColspaceCounter--;  
            if (record.get('checked') == true)
            {
                sReturn+='<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif); background-position: 0px -13px;" /></td>';
            } else {
                sReturn+='<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif);" /></td>';
            }
        }
        if (fHasNext)
            iColspaceCounter--;
        if (fIsPassive) {
            sReturn+='<td style="color:#888888;" colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
        } else {
            sReturn+='<td colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
        }
        if (fHasNext) {
            sReturn+='<td>&gt;</td>';
        }
        return sReturn +'</tr></table>';  

    },
    defMainGridRenderer : function(val, metadata, record, colIdx, store, view) {
        var oAction = record.get('action');
        switch (oAction.type) {
            case 'zone-scene': { // scene, group,zone,force
                var sString = '<table><tr><td style="padding-right:5px;">' + dss.staticDataModel.getImageForScene(oAction.params.zone, oAction.params.group, oAction.params.scene) + "</td>";
                
                sString += "<td>";
                if (oAction.params.force)
                    sString += 'Alles ';

                sString += dss.staticDataModel.getNameForScene(oAction.params.zone, oAction.params.group, oAction.params.scene);
                if (oAction.params.group != 0)
                    sString += " f&uuml;r " + dss.staticDataModel.getNameForGroup(oAction.params.zone, oAction.params.group);
                if (oAction.params.zone != 0)
                    sString += " in " + dss.staticDataModel.getNameForZone(oAction.params.zone);
                sString += "</td></tr></table>";
                return sString;
                break;
            }
            case 'device-scene': {// scene, dsid,force
                var oDevice = dss.staticDataModel.getDevice(oAction.params.dsid);

                var sString = oDevice.name + " in ";
                sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);

                if (oAction.params.scene == 13) {// aus
                    sString = '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>' + sString + " ausschalten</td></tr></table>";
                } else if (oAction.params.scene == 14) {// ein
                    sString = '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>' + sString + " einschalten</td></tr></table>";
                } else if (oAction.params.scene == 51) { // ein loc
                    sString = '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>' + sString + " einschalten mit Lokalpriorit&auml;t</td></tr></table>";
                } else {
                    sString = dss.staticDataModel.getNameForScene(oDevice.ZoneID, oDevice.GroupID, oAction.params.scene) + " f&uuml;r " + sString+ "</td></tr></table>";
                    if (oAction.params.force)
                        sString = 'Alles ' + sString;
                    sString = '<table><tr><td style="padding-right:5px;">'
                            + dss.staticDataModel.getImageForScene(oDevice.ZoneID, oDevice.GroupID, oAction.params.scene) + "</td><td>" + sString;
                }
                return sString;
                break;
            }
            case 'device-value': { // value, dsid
                var oDevice = dss.staticDataModel.getDevice(oAction.params.dsid);
                var sString = '<table><tr><td style="color:#ff0000;">' + Math.round(oAction.params.value / 2.55) + "% f&uuml;r ";
                sString += oDevice.name + " in ";
                sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                sString += "</td></tr></table>";
                return sString;
                break;
            }
            case 'device-blink': {// dsid
                var oDevice = dss.staticDataModel.getDevice(oAction.params.dsid);
                var sString = '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td>';
                sString += "<td>" + oDevice.name + " in ";
                sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                sString += " blinkt</td></tr></table>";
                return sString;
                break;
            }
            case 'zone-blink': {// group,zone
                var sString = '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.baseImagePath + 'sceneIcons/scene_blink.png"></td>';
                sString += "<td>" + dss.staticDataModel.getNameForGroup(oAction.params.zone, oAction.params.group) + " in ";
                sString += dss.staticDataModel.getNameForZone(oAction.params.zone);
                sString += " blinkt</td></tr></table>";
                return sString;
                break;
            }
            case 'custom-event': { // event
                return "Highlevel Event: " + dss.staticDataModel.getHLENameFromId(oAction.params.event);
                break;
            }
            case 'url': { // url
                return "URL: " + oAction.params.url
                break;
            }
            default: {
                return "Unvollst&auml;ndige Aktivit&auml;t";
                break;
            }
        }
    },
    initStores : function(fHiglevelShown) {
        if (Ext.data.StoreManager.lookup('actionConfigurator_l1Store') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'actionConfigurator_l1Store',
                fields : [ 'id', 'name', 'next', 'icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var Aktionen = [ {
                name : 'Aktivit&auml;t in Raum',
                id : 0,
                next : true,
                icon : null,
                passive: (dss.staticDataModel.getZoneArray().length==1)
            }, {
                name : 'einzelnes Ger&auml;t',
                id : 1,
                next : true,
                icon : null,
                passive: (dss.staticDataModel.getZoneArray().length==1)
            }];
            Ext.data.StoreManager.lookup('actionConfigurator_l1Store').add(Aktionen);
            if (fHiglevelShown) {
                Ext.data.StoreManager.lookup('actionConfigurator_l1Store').add( [{
                    name : 'Benutzerdef. Handlung',
                    id : 2,
                    next : true,
                    icon : null,
                    passive:(dss.staticDataModel.getHLE().length==0)
                }]);
            }
            Ext.data.StoreManager.lookup('actionConfigurator_l1Store').add([{
                name : 'URL aufrufen',
                id : 3,
                next : true,
                icon : null
            }, {
                name : '-',
                id : -1,
                next : false,
                icon : null,
                passive:true
            }, {
                name : 'Panik',
                id : 4,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 65)
            }, {
                name : 'Klingeln',
                id : 5,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 73)
            }, {
                name : 'Gehen',
                id : 6,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 72)
            }, {
                name : 'Kommen',
                id : 7,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 71)
            } ]);
        }
        if (Ext.data.StoreManager.lookup('actionConfigurator_zoneStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'actionConfigurator_zoneStore',
                fields : [ 'ZoneID', 'name' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('actionConfigurator_zoneStore').add(dss.staticDataModel.getZoneArray());
        }
        var me = this;
        this.gridStore = Ext.create('Ext.data.Store', {

            fields : [ 'pos', 'action' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            },
            listeners : {
                datachanged : function(store, eOpts) {
                    if (store.getCount()==0)
                        me.lblSelectorAnzeige.setText('keine Aktivit&auml;t',false);
                    else if (store.getCount()==1)
                        me.lblSelectorAnzeige.setText('1 Aktivit&auml;t',false);
                    else
                        me.lblSelectorAnzeige.setText('' + store.getCount() + ' Aktivit&auml;ten',false);
                }
            }
        });
    },
    getGroupStore : function(ZoneID) {
        if (Ext.data.StoreManager.lookup('actionConfigurator_groupStore_' + ZoneID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'actionConfigurator_groupStore_' + ZoneID,
                fields : [ 'group', 'name', 'icon', 'reachable' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oGroup = dss.staticDataModel.getGroupForZone(ZoneID);
            Ext.data.StoreManager.lookup('actionConfigurator_groupStore_' + ZoneID).add(oGroup);
        }
        return Ext.data.StoreManager.lookup('actionConfigurator_groupStore_' + ZoneID);
    },
    getSceneStore : function(ZoneID, groupID) {
        if (Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'actionConfigurator_szeneStore_' + ZoneID + '_' + groupID,
                fields : [ 'id', 'name', 'reachable', 'icon', 'outputMode' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oScenes = dss.staticDataModel.getScenes(ZoneID, groupID);
            for ( var iIndex = 0; iIndex < oScenes.length; iIndex++) {
                var oObject = {};
                oObject.id = oScenes[iIndex].id;
                oObject.reachable = oScenes[iIndex].reachable;
                oObject.icon = oScenes[iIndex].icon;
                if (oScenes[iIndex].name == oScenes[iIndex].defaultName)
                    oObject.name = oScenes[iIndex].name;
                else
                    oObject.name = oScenes[iIndex].defaultName + ' - ' + oScenes[iIndex].name;
                Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add(oObject);
            }

        }
        return Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID);

    },
    getDeviceStore : function(ZoneID) {
        if (Ext.data.StoreManager.lookup('actionConfigurator_deviceStore_' + ZoneID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'actionConfigurator_deviceStore_' + ZoneID,
                fields : [ 'dSID', 'name', 'icon', 'present' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oDevice = dss.staticDataModel.getDevicesForZone(ZoneID, 0);
            Ext.data.StoreManager.lookup('actionConfigurator_deviceStore_' + ZoneID).add(oDevice);
        }
        return Ext.data.StoreManager.lookup('actionConfigurator_deviceStore_' + ZoneID);
    },
    constructGridLvlDeviceScene : function(zoneID, groupID, fAll, fForce) {
        var oSceneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'name', 'icon', 'reachable', 'checkable', 'checked' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        if (fAll == null)
            fAll = false;
        if (fForce == null)
            fForce = false

        var oSceneStore = this.getSceneStore(zoneID, groupID);
        oSceneControlStore.add({
            id : -3,
            name : 'alle Stimmungen anzeigen',
            icon : null,
            reachable : true,
            checkable : true,
            checked : fAll
        });
        oSceneControlStore.add({
            id : -1,
            name : '-',
            icon : null,
            reachable : true,
            passive:true
        });
        oSceneStore.each(function(record) {
            var oNewRecord = record.copy()
            if (oNewRecord.get('reachable') || fAll)
                if (oNewRecord.get('id') < 64) {
                    oSceneControlStore.add(oNewRecord);
                    if (oNewRecord.get('id')==0) {
                        oSceneControlStore.add({
                            id:0,
                            name:'Alles aus',
                            icon:oNewRecord.get('icon'),
                            force:true
                        });
                    }
                }
        });

        this.grids.lvlDeviceScene = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : 174,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            hideHeaders:true,
            store : oSceneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlDeviceScene.parent = this;
        this.macPanel.add(this.grids.lvlDeviceScene);

        this.grids.lvlDeviceScene.on('itemclick', function(grid, record) {
            this.parent.oActualValue=null;
            if (record.get('checkable') != null) {
                if (record.get('checkable')) {
                    var fChecked = !record.get('checked');
                    record.set('checked', fChecked);
                    grid.getSelectionModel().deselectAll();
                    if (record.get('id') == -3) {
                        // alle Stimmungen
                        grid.store.removeAll();

                        grid.store.add({
                            id : -3,
                            name : 'alle Stimmungen anzeigen',
                            icon : null,
                            reachable : true,
                            checkable : true,
                            checked : record.get('checked')

                        });
                        grid.store.add({
                            id : -1,
                            name : '-',
                            icon : null,
                            reachable : true,
                            passive:true
                        });
                        oSceneStore.each(function(record) {
                            var oNewRecord = record.copy();
                            if (oNewRecord.get('reachable') || fChecked)
                                if (oNewRecord.get('id') < 64) {
                                    grid.store.add(oNewRecord);
                                    if (oNewRecord.get('id')==0) {
                                        grid.store.add({
                                            id:0,
                                            name:'Alles aus',
                                            icon:oNewRecord.get('icon'),
                                            force:true
                                        });
                                    }
                                }
                        });

                    }
                    return;
                }
            }
            if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('id') == 1) {
                var dSID = this.parent.grids.lvlDevice.getSelectionModel().getSelection()[0].get('dSID');
                if (dSID != null) {
                    var fForce = false;
                    if (record.get('force')!=null)
                        fForce=record.get('force');
                    var oObject = {
                        type : 'device-scene',
                        params : {
                            dsid : dSID,
                            scene : record.get('id'),
                            force : fForce
                        }
                    };
                    this.parent.setSelectedSubItem(oObject);
                }
            }
        });
        this.grids.lvlDeviceScene.on('itemdblclick', function(grid, record) {
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, true);
            }
        });

    },
    constructGridLvlDeviceActions : function(dSID) {
        var oDeviceActionControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'name', 'icon', 'next' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var oDeviceObject = dss.staticDataModel.getDevice(dSID);
        if (oDeviceObject.GroupID == 1) {
            oDeviceActionControlStore.add({
                id : 5,
                name : 'Stimmung aufrufen',
                icon : null,
                next : true
            });
            /*oDeviceActionControlStore.add({
                id : 1,
                name : 'Ausschalten',
                icon : dss.staticDataModel.getImagePathForScene(0, 1, 0),
                next : false
            });
            oDeviceActionControlStore.add({
                id : 2,
                name : 'Einschalten',
                icon : dss.staticDataModel.getImagePathForScene(0, 1, 5),
                next : false
            });
            oDeviceActionControlStore.add({
                id : 3,
                name : 'Einschalten mit Lokalpriorit&auml;t',
                icon : dss.staticDataModel.getImagePathForScene(0, 1, 5),
                next : false
            });*/
            oDeviceActionControlStore.add({
                id : 4,
                name : 'Blinken',
                icon : dss.staticDataModel.baseImagePath + 'sceneIcons/scene_blink.png',
                next : false
            });
        } else if (oDeviceObject.GroupID == 8) {
            oDeviceActionControlStore.add({
                id : 1,
                name : 'Ausschalten',
                icon : dss.staticDataModel.getImagePathForScene(0, oDeviceObject.GroupID, 0),
                next : false
            });
            oDeviceActionControlStore.add({
                id : 2,
                name : 'Einschalten',
                icon : dss.staticDataModel.getImagePathForScene(0, oDeviceObject.GroupID, 5),
                next : false
            });
        } else {
            oDeviceActionControlStore.add({
                id : 5,
                name : 'Stimmung aufrufen',
                icon : null,
                next : true
            });
            oDeviceActionControlStore.add({
                id : 4,
                name : 'Blinken',
                icon : dss.staticDataModel.baseImagePath + 'sceneIcons/scene_blink.png',
                next : false
            });
        }

        this.grids.lvlDeviceAction = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            hideHeaders:true,
            store : oDeviceActionControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlDeviceAction.parent = this;

        this.grids.lvlDeviceAction.on('itemclick', function(grid, record) {
            this.parent.oActualValue=null;
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
            var id = record.get('id');
            if (id == 5) {
                var dSID = this.parent.grids.lvlDevice.getSelectionModel().getSelection()[0].get('dSID');
                var oDeviceObject = dss.staticDataModel.getDevice(dSID);
                this.parent.constructGridLvlDeviceScene(oDeviceObject.ZoneID, oDeviceObject.GroupID);
            } else {
                if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('id') == 1) {
                    var dSID = this.parent.grids.lvlDevice.getSelectionModel().getSelection()[0].get('dSID');
                    if (dSID != null) {
                        switch (id) {
                            case 1:
                                var oObject = {
                                    type : 'device-scene',
                                    params : {
                                        dsid : dSID,
                                        scene : 13,
                                        force : false
                                    }
                                };
                                this.parent.setSelectedSubItem(oObject);
                            break;
                            case 2:
                                var oObject = {
                                    type : 'device-scene',
                                    params : {
                                        dsid : dSID,
                                        scene : 14,
                                        force : false
                                    }
                                };
                                this.parent.setSelectedSubItem(oObject);
                            break;
                            case 3:
                                var oObject = {
                                    type : 'device-scene',
                                    params : {
                                        dsid : dSID,
                                        scene : 51,
                                        force : false
                                    }
                                };
                                this.parent.setSelectedSubItem(oObject);
                            break;
                            case 4:
                                var oObject = {
                                    type : 'device-blink',
                                    params : {
                                        dsid : dSID,
                                    }
                                };
                                this.parent.setSelectedSubItem(oObject);
                            break;
                        }

                    }
                }
            }
        });

        this.grids.lvlDeviceAction.on('itemdblclick', function(grid, record) {          
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, true);
            }
        });

        this.macPanel.add(this.grids.lvlDeviceAction);

    },
    constructGridLvlDevice : function(zoneID) {
        var oDeviceControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'dSID', 'name', 'icon', 'present' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oDeviceStore = this.getDeviceStore(zoneID);
        oDeviceStore.each(function(record) {
            var oNewRecord = record.copy()
            if (oNewRecord.get('present'))
                if (oNewRecord.get('outputMode') != 0)
                    oDeviceControlStore.add(oNewRecord);
        });
        this.grids.lvlDevice = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            hideHeaders:true,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oDeviceControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlDevice.parent = this;
        this.grids.lvlDevice.on('itemclick', function(grid, record) {
            this.parent.oActualValue=null;
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
            var dSID = record.get('dSID');
            this.parent.constructGridLvlDeviceActions(dSID);
        });
        this.macPanel.add(this.grids.lvlDevice);
    },
    constructGridLvlGroupScene : function(zoneID, groupID, fAll, fForce) {
        var oSceneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'name', 'icon', 'reachable', 'checkable', 'checked' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        if (fAll == null)
            fAll = false;
        if (fForce == null)
            fForce = false
        var oSceneStore = this.getSceneStore(zoneID, groupID);
        oSceneControlStore.add({
            id : -3,
            name : 'alle Stimmungen anzeigen',
            icon : null,
            reachable : true,
            checkable : true,
            checked : fAll

        });
        oSceneControlStore.add({
            id : -1,
            name : '-',
            icon : null,
            reachable : true
        });
        oSceneStore.each(function(record) {
            var oNewRecord = record.copy()
            if (oNewRecord.get('reachable') || fAll) {
                if (oNewRecord.get('id') < 64) {
                    oSceneControlStore.add(oNewRecord);
                    if (oNewRecord.get('id')==0) {
                        oSceneControlStore.add({
                            id:0,
                            name:'Alles aus',
                            icon:oNewRecord.get('icon'),
                            force:true
                        });
                    }
                }
            }
        });

        this.grids.lvlScene = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : 324,
            autoScroll : true,
            hideHeaders:true,
            viewConfig : {
                stripeRows : true
            },
            store : oSceneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlScene.parent = this;
        this.grids.lvlScene.on('itemclick', function(grid, record) {
            this.parent.oActualValue=null;
            if (record.get('checkable') != null) {
                if (record.get('checkable')) {
                    var fChecked = !record.get('checked');
                    record.set('checked', fChecked);
                    grid.getSelectionModel().deselectAll();
                    if (record.get('id') == -3) {
                        // alle Stimmungen
                        grid.store.removeAll();

                        grid.store.add({
                            id : -3,
                            name : 'alle Stimmungen anzeigen',
                            icon : null,
                            reachable : true,
                            checkable : true,
                            checked : record.get('checked')

                        });                       
                        grid.store.add({
                            id : -1,
                            name : '-',
                            icon : null,
                            reachable : true
                        });
                        oSceneStore.each(function(record) {
                            var oNewRecord = record.copy();
                            if (oNewRecord.get('reachable') || fChecked)
                                if (oNewRecord.get('id') < 64) {
                                    grid.store.add(oNewRecord);
                                    if (oNewRecord.get('id')==0) {
                                        if (groupID==2) {
                                            oSceneControlStore.add({
                                                id:0,
                                                name:'Alle zu',
                                                icon:oNewRecord.get('icon'),
                                                force:true
                                            });
                                        } else {
                                            oSceneControlStore.add({
                                                id:0,
                                                name:'Alles aus',
                                                icon:oNewRecord.get('icon'),
                                                force:true
                                            });
                                        }
                                    }
                                }
                        });

                    }
                }
            }
            if (record.get('id')>=0) {               
                if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('id') == 0) {
                    var zoneID = this.parent.grids.lvlRoom.getSelectionModel().getSelection()[0].get('ZoneID');
                    var groupID = this.parent.grids.lvlGroup.getSelectionModel().getSelection()[0].get('group');
                    if (zoneID != null) {
                        if (groupID != null) {
                            var fForce = false;
                            if (record.get('force')!=null)
                                fForce=record.get('force');
                            var oObject = {
                                type : 'zone-scene',
                                params : {
                                    zone : zoneID,
                                    group : groupID,
                                    scene : record.get('id'),
                                    force : fForce
                                }
                            };
                            this.parent.setSelectedSubItem(oObject);
                        }
                    }
                }
            }
        });
        this.grids.lvlScene.on('itemdblclick', function(grid, record) {
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, true);
            }
        });

        this.macPanel.add(this.grids.lvlScene);

    },
    constructGridLvlRoom : function() {
        var oZoneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'ZoneID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oZoneStore = Ext.data.StoreManager.lookup('actionConfigurator_zoneStore');
        oZoneStore.each(function(record) {
            var oNewRecord = record.copy()
            if (oNewRecord.get('ZoneID') != 0)
                oZoneControlStore.add(oNewRecord);
        });

        
        oZoneControlStore.add([{name:'Alle R&auml;me',ZoneID:0}]);
        
        this.grids.lvlRoom = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            hideHeaders:true,
            viewConfig : {
                stripeRows : true
            },
            store : oZoneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlRoom.parent = this;
        this.grids.lvlRoom.on('itemclick', function(grid, record) {
            this.parent.oActualValue=null;
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
            this.parent.macPanel.remove(this.parent.grids.lvlGroup);
            this.parent.macPanel.remove(this.parent.grids.lvlScene);
            this.parent.macPanel.remove(this.parent.grids.lvlDevice);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
            if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('id') == 0) {
                var zoneID = record.get('ZoneID');
                this.parent.constructGridLvlGroup(zoneID);
            } else if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('id') == 1) {
                var zoneID = record.get('ZoneID');
                this.parent.constructGridLvlDevice(zoneID);
            }
        });
        this.macPanel.add(this.grids.lvlRoom);
    },
    constructGridLvlHigh : function() {

        var oStore = Ext.create('Ext.data.Store', {
            fields : [ {name:'name',sortType:'asUCText'},'id' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });        
        if (dss.staticDataModel.HLECache!=null)
            if (dss.staticDataModel.HLECache.length>0) {
                for (var iIndex=0;iIndex<dss.staticDataModel.HLECache.length;iIndex++)
                    oStore.add( {   
                        name:dss.staticDataModel.HLECache[iIndex].name,
                        id:dss.staticDataModel.HLECache[iIndex].id
                    });
            }
        oStore.sort('name','ASC');
        this.grids.lvlHighLevelEvent = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            hideHeaders:true,
            viewConfig : {
                stripeRows : true
            },
            store : oStore,
            columns : [ {
                sortable : true,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table><tr><td width="100%">' + record.get('name') + '</td></tr></table>';
                }
            } ]
        });
        this.grids.lvlHighLevelEvent.parent = this;
        this.macPanel.add(this.grids.lvlHighLevelEvent);

        this.grids.lvlHighLevelEvent.on('itemdblclick', function(grid, record) {
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, true);
            }
        });

        this.grids.lvlHighLevelEvent.on('itemclick', function(grid, record) {
            
            var oObject = {
                type : 'custom-event',
                params : {
                    event : record.get('id'),
                }
            };
            this.parent.setSelectedSubItem(oObject);
        });

    },
    constructGridLvlURL : function() {

        this.grids.lvlURLText = Ext.create('Ext.form.field.Text', {
            xtype : 'textfield',
            name : 'url',
            margin : 5,
            fieldLabel : 'URL',
            allowBlank : false,
            labelWidth : 30,
            width : 614,
            enableKeyEvents: true,
            listeners: {
                keyup:function (edit) 
                {
                    edit.parent.oActualValue=null;
                    if (edit.isValid()) {
                        var oObject = {
                            type : 'url',
                            params : {
                                url : edit.getValue(),
                            }
                        };
                        edit.parent.setSelectedSubItem(oObject);
                    }
                }
            }
        });
        this.grids.lvlURL = Ext.create('Ext.panel.Panel', {
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            items : [ this.grids.lvlURLText /*, this.grids.lvlURLButton*/ ]
        });

        this.grids.lvlURL.parent = this;
        this.grids.lvlURLText.parent = this;
        //this.grids.lvlURLButton.parent = this;
        this.macPanel.add(this.grids.lvlURL);
    },
    constructGridLvlGroup : function(zoneID) {
        var oGroupControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'group', 'name', 'icon', 'reachable' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oGroupStore = this.getGroupStore(zoneID);
        oGroupStore.each(function(record) {
            var oNewRecord = record.copy()
            if (oNewRecord.get('reachable')) {
                if ((oNewRecord.get('group') != 0) && (oNewRecord.get('group') != 8))
                    oGroupControlStore.add(oNewRecord);
                if (oNewRecord.get('group') == 1)
                    oGroupControlStore.add({
                        id : -1,
                        group : null,
                        name : oNewRecord.get('name') + ' blinken',
                        icon : dss.staticDataModel.baseImagePath + 'sceneIcons/scene_blink.png',
                        reachable : oNewRecord.get('reachable')
                    });
            }
        });
        oGroupControlStore.add({
            group : -1,
            name : '-',
            icon : null,
            reachable : true
        });
        var oSceneGroup0Store = this.getSceneStore(zoneID, 0);
        oSceneGroup0Store.each(function(record) {
            var oNewRecord = record.copy()
            if (oNewRecord.get('reachable'))
                oGroupControlStore.add(oNewRecord);
        });

        this.grids.lvlGroup = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            hideHeaders:true,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oGroupControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlGroup.on('itemdblclick', function(grid, record) {
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, true);
            }
        });

        this.grids.lvlGroup.on('itemclick', function(grid, record) {
            this.parent.oActualValue=null;
            this.parent.macPanel.remove(this.parent.grids.lvlScene);
            if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('id') == 0) {
                var zoneID = this.parent.grids.lvlRoom.getSelectionModel().getSelection()[0].get('ZoneID');
                var groupID = record.get('group');
                if ((zoneID != null) && (groupID != null)) {
                    this.parent.constructGridLvlGroupScene(zoneID, groupID);
                } else {
                    if (record.get('id')!=null) {
                        if (record.get('id') < 0) {
                            var oObject = {
                                type : 'zone-blink',
                                params : {
                                    zone : zoneID,
                                    group : Math.abs(record.get('id'))
                                }
                            };                            
                            this.parent.setSelectedSubItem(oObject);
                        } else {
                            var oObject = {
                                type : 'zone-scene',
                                params : {
                                    zone : zoneID,
                                    group : 0,
                                    scene : record.get('id'),
                                    force : false
                                }
                            };
                            this.parent.setSelectedSubItem(oObject);
                        }
                    }
                }
            }
        });


        this.grids.lvlGroup.parent = this;
        this.macPanel.add(this.grids.lvlGroup);
    },
    constructMacGrids : function() {        
        var lvl1TempStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'name', 'next', 'icon' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var lvl1Store = Ext.data.StoreManager.lookup('actionConfigurator_l1Store');
        lvl1Store.each(function(record) {
            var oNewRecord = record.copy();
            lvl1TempStore.add(oNewRecord);
        });

        this.grids.lvl1 = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            hideHeaders:true,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : lvl1TempStore,
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvl1.parent = this;
        this.grids.lvl1.on('itemdblclick', function(grid, record) {
            if (this.parent.oActualValue !=null)
                this.parent.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, true);
        });
        
        this.grids.lvl1.on('itemclick', function(grid, record) {
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
            this.parent.macPanel.remove(this.parent.grids.lvlRoom);
            this.parent.macPanel.remove(this.parent.grids.lvlHighLevelEvent);
            this.parent.macPanel.remove(this.parent.grids.lvlURL);
            this.parent.macPanel.remove(this.parent.grids.lvlGroup);
            this.parent.macPanel.remove(this.parent.grids.lvlScene);
            this.parent.macPanel.remove(this.parent.grids.lvlDevice);
            this.parent.oActualValue =null;
            var fIsPassive=false;
            if (record.get('passive')!=null) {
                if (record.get('passive')==true) {
                    this.getSelectionModel().deselect(record);
                    fIsPassive=true;
                }
            }
            
            if (!fIsPassive) {
                if (record.get('id') == 0) {
                    this.parent.constructGridLvlRoom();
                } else if (record.get('id') == 1) {
                    this.parent.constructGridLvlRoom();
                } else if (record.get('id') == 2) {
                    this.parent.constructGridLvlHigh();
                } else if (record.get('id') == 3) {
                    this.parent.constructGridLvlURL();
                } else if (record.get('id') >3 ) { 
                    var oObject = {
                        type : 'zone-scene',
                        params : {
                            zone : 0,
                            group : 0,
                            scene : null,
                            force : false
                        }
                    };
    
                    if (record.get('id') == 4) // panic
                    {
                        oObject.params.scene = 65;
                    }
                    if (record.get('id') == 5) // klingel
                    {
                        oObject.params.scene = 73;
                    }
    
                    if (record.get('id') == 6) // gehen
                    {
                        oObject.params.scene = 72;
                    }
                    if (record.get('id') == 7) // kommen
                    {
                        oObject.params.scene = 71;
                    }
                    if (record.get('id') == 8) // schlafen
                    {
                        oObject.params.scene = 69;
                    }
                    if (record.get('id') == 9) // aufwachen
                    {
                        oObject.params.scene = 70;
                    }
                    if (oObject.params.scene != null) {
                        this.parent.setSelectedSubItem(oObject);
                    }
                }
            } 
            this.parent.updatePanelDescription();
            this.parent.macPanel.doLayout();
        });
    },
    setSelectedSubItem : function(oObject) {
        this.oActualValue=oObject;
        if (this.mainGrid.getSelectionModel().getSelection().length == 0) {
            var oNewRecord=this.gridStore.add({
                pos : 0,
                action : oObject
            });
            this.mainGrid.getSelectionModel().select(oNewRecord);
        } else {
            this.mainGrid.getSelectionModel().getSelection()[0].set('action', oObject);
            this.mainGrid.getSelectionModel().getSelection()[0].commit();
        }
        this.removeCls('myInvalid');
        this.updatePanelDescription();
    },
    setMacGrid : function(oObject) {
        
        this.macPanel.remove(this.grids.lvlDeviceScene);
        this.macPanel.remove(this.grids.lvlDeviceAction);
        this.macPanel.remove(this.grids.lvlRoom);
        this.macPanel.remove(this.grids.lvlHighLevelEvent);
        this.macPanel.remove(this.grids.lvlURL);
        this.macPanel.remove(this.grids.lvlGroup);
        this.macPanel.remove(this.grids.lvlScene);
        this.macPanel.remove(this.grids.lvlDevice);
        this.oActualValue=oObject;
        if (oObject == null) {
            var oTempGrid = this.grids.lvl1;
            oTempGrid.store.removeAll();
            var lvl1Store = Ext.data.StoreManager.lookup('actionConfigurator_l1Store');
            lvl1Store.each(function(record) {
                var oNewRecord = record.copy();
                oTempGrid.store.add(oNewRecord);
            });
            this.grids.lvl1.getSelectionModel().deselectAll();
        } else
            switch (oObject.type) {
                case 'zone-scene':
                    this.grids.lvl1.getSelectionModel().select(0);
                    if (oObject.params.zone == 0) {
                        if (oObject.params.scene == 65)
                            this.grids.lvl1.getSelectionModel().select(5);
                        if (oObject.params.scene == 73)
                            this.grids.lvl1.getSelectionModel().select(6);
                        if (oObject.params.scene == 72)
                            this.grids.lvl1.getSelectionModel().select(7);
                        if (oObject.params.scene == 71)
                            this.grids.lvl1.getSelectionModel().select(8);
                        if (oObject.params.scene == 69)
                            this.grids.lvl1.getSelectionModel().select(9);
                        if (oObject.params.scene == 70)
                            this.grids.lvl1.getSelectionModel().select(10);
                    } else {
                        this.constructGridLvlRoom();
                        var oRecordZone = this.grids.lvlRoom.store.find('ZoneID', oObject.params.zone);
                        if (oRecordZone != -1)
                            this.grids.lvlRoom.getSelectionModel().select(oRecordZone);
                        else
                            break;
                        this.constructGridLvlGroup(oObject.params.zone)
                        if (oObject.params.group == 0) {
                            var oRecordGroup = this.grids.lvlGroup.store.find('id', oObject.params.scene);
                            if (oRecordGroup != -1)
                                this.grids.lvlGroup.getSelectionModel().select(oRecordGroup);
                            else 
                                break;
                        } else {
                            var oRecordGroup = this.grids.lvlGroup.store.find('group', oObject.params.group);
                            if (oRecordGroup != -1)
                                this.grids.lvlGroup.getSelectionModel().select(oRecordGroup);
                            else
                                break;
                            this.constructGridLvlGroupScene(oObject.params.zone, oObject.params.group, false, oObject.params.force);

                            var oRecordScene = this.grids.lvlScene.store.find('id', oObject.params.scene);
                            if (oRecordScene != -1) {
                                if (oObject.params.force)
                                    oRecordScene++;
                                this.grids.lvlScene.getSelectionModel().select(oRecordScene);
                            } else {
                                this.macPanel.remove(this.grids.lvlScene);
                                this.constructGridLvlGroupScene(oObject.params.zone, oObject.params.group, true, oObject.params.force);
                                var oRecordScene = this.grids.lvlScene.store.find('id', oObject.params.scene);
                                if (oRecordScene != -1) {
                                    if (oObject.params.force)
                                        oRecordScene++;
                                    this.grids.lvlScene.getSelectionModel().select(oRecordScene);
                                }
                                else 
                                    break;
                            }
                            if (oRecordScene > 11) {
                                var me = this;
                                var fn = function() {
                                    me.grids.lvlScene.setScrollTop((oRecordScene) * 21);
                                };
                                window.setTimeout(fn, 10);
                            }

                        }
                    }
                break;
                case 'device-scene':
                    this.grids.lvl1.getSelectionModel().select(1);
                    var zoneID = dss.staticDataModel.getDevice(oObject.params.dsid).ZoneID;
                    var groupID = dss.staticDataModel.getDevice(oObject.params.dsid).GroupID;
                    this.constructGridLvlRoom();
                    var oRecordZone = this.grids.lvlRoom.store.find('ZoneID', zoneID);
                    if (oRecordZone != -1)
                        this.grids.lvlRoom.getSelectionModel().select(oRecordZone);
                    else
                        break;
                    this.constructGridLvlDevice(zoneID);
                    var oRecordDevice = this.grids.lvlDevice.store.find('dSID', oObject.params.dsid);
                    if (oRecordDevice != -1)
                        this.grids.lvlDevice.getSelectionModel().select(oRecordDevice);
                    else
                        break;
                    this.constructGridLvlDeviceActions(oObject.params.dsid);
                    if (oObject.params.scene == 13) { // id:1
                        var iIndex = this.grids.lvlDeviceAction.store.find('id', 1);
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex);
                    } else if (oObject.params.scene == 14) { // id:2
                        var iIndex = this.grids.lvlDeviceAction.store.find('id', 2);
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex);
                    } else if (oObject.params.scene == 51) { // id:3
                        var iIndex = this.grids.lvlDeviceAction.store.find('id', 3);
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex);
                    } else {
                        var iIndex = this.grids.lvlDeviceAction.store.find('id', 5);
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex);
                        else 
                            break;
                        this.constructGridLvlDeviceScene(zoneID, groupID);

                        var oRecordScene = this.grids.lvlDeviceScene.store.find('id', oObject.params.scene, false, oObject.params.force);
                        if (oRecordScene != -1) {
                            if (oObject.params.force)
                                oRecordScene++;
                            this.grids.lvlDeviceScene.getSelectionModel().select(oRecordScene);
                        } else {
                            this.macPanel.remove(this.grids.lvlDeviceScene);
                            this.constructGridLvlDeviceScene(oObject.params.zone, oObject.params.group, true, oObject.params.force);
                            var oRecordScene = this.grids.lvlDeviceScene.store.find('id', oObject.params.scene);
                            if (oRecordScene != -1) {
                                if (oObject.params.force)
                                    oRecordScene++;
                                this.grids.lvlDeviceScene.getSelectionModel().select(oRecordScene);
                            }
                        }
                        if (oRecordScene > 11) {
                            var me = this;
                            var fn = function() {
                                me.grids.lvlDeviceScene.setScrollTop((oRecordScene) * 21);
                            };
                            window.setTimeout(fn, 10);
                        }

                    }
                break;
                case 'device-value':
                    // nicht unterstuetzt aktuell
                break;
                case 'device-blink':
                    this.grids.lvl1.getSelectionModel().select(1);
                    var zoneID = dss.staticDataModel.getDevice(oObject.params.dsid).ZoneID;
                    var groupID = dss.staticDataModel.getDevice(oObject.params.dsid).GroupID;
                    this.constructGridLvlRoom();
                    var oRecordZone = this.grids.lvlRoom.store.find('ZoneID', zoneID);
                    if (oRecordZone != -1)
                        this.grids.lvlRoom.getSelectionModel().select(oRecordZone);
                    else 
                        break;
                    this.constructGridLvlDevice(zoneID);
                    var oRecordDevice = this.grids.lvlDevice.store.find('dSID', oObject.params.dsid);
                    if (oRecordDevice != -1)
                        this.grids.lvlDevice.getSelectionModel().select(oRecordDevice);
                    else
                        break;
                    this.constructGridLvlDeviceActions(oObject.params.dsid);
                    var iIndex = this.grids.lvlDeviceAction.store.find('id', 4);
                    if (iIndex!=-1)
                        this.grids.lvlDeviceAction.getSelectionModel().select(iIndex);
                break;
                case 'zone-blink':
                    this.grids.lvl1.getSelectionModel().select(0);
                    this.constructGridLvlRoom();
                    var oRecordZone = this.grids.lvlRoom.store.find('ZoneID', oObject.params.zone);
                    if (oRecordZone != -1)
                        this.grids.lvlRoom.getSelectionModel().select(oRecordZone);
                    else
                        break;
                    this.constructGridLvlGroup(oObject.params.zone)
                    var oRecordGroup = this.grids.lvlGroup.store.find('id', -1 * oObject.params.group);
                    if (oRecordGroup != -1)
                        this.grids.lvlGroup.getSelectionModel().select(oRecordGroup);
                    else
                        break;
                break;
                case 'custom-event':
                    this.grids.lvl1.getSelectionModel().select(2);
                    this.constructGridLvlHigh();
                    var oRecord = this.grids.lvlHighLevelEvent.store.find('id', oObject.params.event);
                    if (oRecord != -1)
                        this.grids.lvlHighLevelEvent.getSelectionModel().select(oRecord);
                break;
                case 'url':
                    this.grids.lvl1.getSelectionModel().select(3);
                    this.constructGridLvlURL();
                    this.grids.lvlURLText.setValue(oObject.params.url);
                break;
            }
        this.updatePanelDescription();
    },
    constructor : function(config) {
        Ext.tip.QuickTipManager.init();
        var fHighLevel=true;
        if (config.noHighlevel!=null)
            if (config.noHighlevel)
                fHighLevel=false;
        this.initStores(fHighLevel);
        this.constructMacGrids();
        this.lblSelectorAnzeige = Ext.create('Ext.form.Label', {
            width : 200,
            height : 22,
            padding : 4,
            style : {
                textAlign : 'right',
            }
        });

        this.oButtonNew = Ext.create('Ext.button.Button', {
            iconCls : 'icon-add-action',
            text : 'Neue Aktivit&auml;t',
            handler : function() {
                this.parent.oActualValue=null;
                this.parent.macPanel.expand(true);
                
                this.parent.setMacGrid();
                if (this.parent.mainGrid.getSelectionModel().getSelection() != null)
                    this.parent.mainGrid.getSelectionModel().deselect(this.parent.mainGrid.getSelectionModel().getSelection()[0]);
            }
        });
        this.oButtonNew.parent = this;

        this.oButtonEdit = Ext.create('Ext.button.Button', {
            iconCls : 'icon-edit-action',
            text : 'Aktivit&auml;t bearbeiten',
            disabled : true,
            handler : function() {
                if (this.parent.macPanel.collapsed) {
                    this.parent.macPanel.expand(true);
                    this.parent.oActualValue=(this.parent.mainGrid.getSelectionModel().getSelection()[0]).get('action');
                    this.parent.setMacGrid(this.parent.oActualValue);
                } else {
                    this.parent.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, true);                    
                }
            }
        });
        this.oButtonEdit.parent = this;

        this.oButtonUp = Ext.create('Ext.button.Button', {
            iconCls : 'icon-left-action',
            disabled : true,
            handler : function() {
                var iIndex = this.parent.mainGrid.store.indexOf(this.parent.mainGrid.getSelectionModel().getSelection()[0]);
                this.parent.mainGrid.getSelectionModel().select(iIndex - 1);
                this.parent.setMacGrid((this.parent.mainGrid.getSelectionModel().getSelection()[0]).get('action'));
            }
        });
        this.oButtonUp.parent = this;

        this.oButtonDown = Ext.create('Ext.button.Button', {
            iconCls : 'icon-right-action',
            disabled : true,
            handler : function() {
                var iIndex = this.parent.mainGrid.store.indexOf(this.parent.mainGrid.getSelectionModel().getSelection()[0]);
                this.parent.mainGrid.getSelectionModel().select(iIndex + 1);
                this.parent.setMacGrid((this.parent.mainGrid.getSelectionModel().getSelection()[0]).get('action'));
            }
        });
        this.oButtonDown.parent = this;

        this.oButtonDelete = Ext.create('Ext.button.Button', {
            iconCls : 'icon-delete-action',
            tooltip: 'Aktivit&auml;t l&ouml;schen',
            disabled : true,
            handler : function() {
                this.parent.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, true);
                this.parent.gridStore.remove(this.parent.mainGrid.getSelectionModel().getSelection()[0]);
            }
        });
        this.oButtonDelete.parent = this;

        this.mainGrid = Ext.create('Ext.grid.Panel', {
            enableColumnHide : false,
            enableColumnMove : false,
            selType : 'rowmodel',
            border : '0',
            region : 'center',
            height : "100%",
            store : this.gridStore,
            hideHeaders : true,
            autoScroll: false,
            columns : [ {
                header : 'Aktion',
                dataIndex : 'action',
                sortable : false,
                hideable : false,
                flex:1,
                renderer : this.defMainGridRenderer
            } ],
            tbar : [ this.oButtonNew, this.oButtonEdit,
            // { xtype: 'button', text: 'Erweiterte Ansicht',
            // id: 'action-selector-btn-extended' ,
            // disabled:true},
            '->', this.lblSelectorAnzeige, this.oButtonUp, this.oButtonDown, this.oButtonDelete ]
        });
        this.mainGrid.parent = this;
        this.mainGrid.on({
            selectionchange : function(view, selections, options) {
                if (selections.length > 0) {
                    this.parent.oButtonEdit.setDisabled(false);
                    this.parent.oButtonDelete.setDisabled(false);
                    var selIndex = -1;
                    for ( var iIndex = 0; iIndex < view.store.getCount(); iIndex++) {
                        if (view.store.getAt(iIndex) == selections[0])
                            selIndex = iIndex;
                    }
                    this.parent.oButtonUp.setDisabled(selIndex == 0);
                    this.parent.oButtonDown.setDisabled(selIndex == (view.store.getCount() - 1));
                    var iIndex = this.parent.mainGrid.store.indexOf(this.parent.mainGrid.getSelectionModel().getSelection()[0]);
                    this.parent.lblSelectorAnzeige.setText('Aktivit&auml;t ' + (iIndex + 1) + ' von ' + view.store.getCount(),false);
                } else {
                    this.parent.oButtonEdit.setDisabled(true);
                    this.parent.oButtonDelete.setDisabled(true);
                    this.parent.oButtonUp.setDisabled(true);
                    this.parent.oButtonDown.setDisabled(true);
                    if (view.store.getCount()==0)
                        this.parent.lblSelectorAnzeige.setText('keine Aktivit&auml;t',false);
                    else if (view.store.getCount()==1)
                        this.parent.lblSelectorAnzeige.setText('1 Aktivit&auml;t',false);
                    else
                        this.parent.lblSelectorAnzeige.setText('' + view.store.getCount() + ' Aktivit&auml;ten',false);
                }
            },
            itemdblclick : function(grid, record) {
                this.parent.macPanel.expand(true);
                this.parent.setMacGrid((this.parent.mainGrid.getSelectionModel().getSelection()[0]).get('action'));
            }

        });
        this.macPanel = Ext.create('Ext.panel.Panel', {
            border : '0',
            region : 'south',
            title : 'Aktivit&auml;t Bearbeiten anzeigen',
            collapsible : true,
            collapsed : false,
            collapseMode : 'header',
            autoScroll : true,
            height : 320,
            layout : {
                type : 'hbox'
            },
            items : [ this.grids.lvl1 ],
            listeners : {
                collapse : function(pPanel) {
                    pPanel.up().macPanel.setTitle('');
                    pPanel.up().oButtonEdit.setDisabled(pPanel.up().mainGrid.getSelectionModel().getSelection().length==0);
                    pPanel.up().oButtonEdit.setText('Aktivit&auml;t bearbeiten');
                    pPanel.up().mainGrid.doLayout();
                 },
                expand : function(pPanel) {
                    pPanel.up().updatePanelDescription();
                    pPanel.up().oButtonEdit.setDisabled(false);
                    pPanel.up().oButtonEdit.setText('Alle Aktivit&auml;ten anzeigen');
                    pPanel.up().mainGrid.doLayout();
                }
            },
            scroll : 'horizontal'

        });

        Ext.apply(this, {
            items : [ this.mainGrid, this.macPanel ]
        });
        defbug=this;
        this.callParent(arguments);

    },
    reset : function() {
        this.setValue(null);
    },
    tabChange : function(fActive) {
        
    }, 
    setValue : function(values) {
        this.macPanel.remove(this.grids.lvlDeviceScene);
        this.macPanel.remove(this.grids.lvlDeviceAction);
        this.macPanel.remove(this.grids.lvlRoom);
        this.macPanel.remove(this.grids.lvlHighLevelEvent);
        this.macPanel.remove(this.grids.lvlURL);
        this.macPanel.remove(this.grids.lvlGroup);
        this.macPanel.remove(this.grids.lvlScene);
        this.macPanel.remove(this.grids.lvlDevice);
        var me = this;
        this.removeCls('myInvalid');
        if (values == null) {
            this.gridStore.removeAll();
            this.doLayout();
            this.macPanel.expand(false);
            this.lblSelectorAnzeige.setText('keine Aktivit&auml;t',false);
        } else {
            this.gridStore.removeAll();
            for ( var iIndex = 0; iIndex < values.length; iIndex++) {
                var oObject = {
                    type : values[iIndex].type,
                    params : {}
                };
                for ( var sKey in values[iIndex]) {
                    if (sKey != "type")
                        oObject.params[sKey] = values[iIndex][sKey];
                }
                this.gridStore.add({
                    action : oObject
                });
            }
            this.mainGrid.getSelectionModel().select(0);
            if (values.length==1) {
                this.macPanel.expand(false);
                this.oActualValue=(this.mainGrid.getSelectionModel().getSelection()[0]).get('action');
                this.setMacGrid(this.oActualValue);
            }
            else
                this.macPanel.collapse(Ext.Component.DIRECTION_BOTTOM, false);
        }
    },
    isValid : function() {
        var valid = (this.gridStore.getCount() > 0);
      /*  this.gridStore.each(function(record) {
            if (record.type==null)
                valid=false;
            else if (record.type=="undefined")
                valid=false;
        }); */
        if (valid)
            this.removeCls('myInvalid');
        else
            this.addCls('myInvalid');
        return valid;
    },
    getValue : function() {
        var oResult = [];
        this.gridStore.each(function(record) {
            var oObject = {};
            var oRecord = record.get('action');
            oObject.type = oRecord.type;
            for ( var oKey in oRecord.params) {
                oObject[oKey] = oRecord.params[oKey];
            }
            oResult.push(oObject);
        });
        return oResult;
    }
}); // DSS.component.ActionConfigurator

var defbug;
